SystemOrganization addCategory: #SWAOBExtensions!

!OBButtonBar methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 16:32'!
addButtons

	| lastGroup |
	model commands
		select: [:cmd | cmd isActive]
		thenDo: [:cmd |
			(lastGroup notNil and: [lastGroup ~= cmd group])
				ifTrue: [self addMorphBack: (PanelMorph new
						hResizing: #rigid;
						vResizing: #rigid;
						extent: 5@1;
						fillStyle: Color transparent)].
			self addButtonFor: cmd.
			lastGroup := cmd group].! !

!OBButtonBar methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 16:20'!
adoptPaneColor: aColor
	self submorphs do: [:ea |
		(ea isKindOf: PluggableButtonMorphPlus)
			ifTrue: [ea onColor: aColor offColor: aColor whiter]].
	super adoptPaneColor: aColor.! !

!OBButtonBar methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 16:23'!
updateCommands
	
	self
		removeAllMorphs;
		addButtons.! !

!OBEnhancementButtonBar methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 16:28'!
adoptPaneColor: aColor
	(self submorphs reject: [:ea | ea isKindOf: OBBackButtonMorph]) do: [:ea | 
		(ea isKindOf: PluggableButtonMorphPlus)
			ifTrue: [ea onColor: aColor offColor: aColor whiter]].
	super adoptPaneColor: aColor! !

!OBEnhancementButtonBar methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 16:28'!
updateCommands
	self removeAllMorphs.
	
	self
		addMorphBack: model createBackButton;
		addMorphBack: model createForwardButton;
		addButtons.! !

!OBCmdBrowseImplementors methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:34'!
icon

	^ #xpfCtPageCodeIcon! !

!OBCmdBrowseImplementors methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:34'!
iconOnly

	^ true! !

!OBCmdBrowseSenders methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:28'!
icon

	^ #xpfCtTransmitBlueIcon! !

!OBButtonModel class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 17:08'!
withLabel: aString inBar: aRadioButtonBar longDescription: aToolTip icon: aSymbol

	^ self new
		label: aString;
		bar: aRadioButtonBar;
		longDescription: aToolTip;
		icon: aSymbol! !

!OBButtonModel methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 17:04'!
icon

	^ icon! !

!OBButtonModel methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 16:58'!
icon: aMorph

	icon := aMorph.! !

!OBButtonModel methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 17:03'!
iconOnly

	iconOnly ifNil: [self iconOnly: false].
	^ iconOnly! !

!OBButtonModel methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 17:03'!
iconOnly: aBoolean

	iconOnly := aBoolean.! !

!OBButtonModel methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 17:04'!
labelMorph
	
	| morph lm |
	(Smalltalk classNamed: #UITheme) ifNotNilDo: [:uit |
		morph := uit current buttonLabelForText: label].
	
	morph ifNil: [morph := (StringMorph 
		contents: label
		font: TextStyle defaultFont).
		(label isText and: [label hasColor]) ifFalse: [morph color: (self isEnabled ifTrue: [Color black] ifFalse: [Color gray])]].
	
	self icon ifNil: [^ morph].
	self iconOnly ifTrue: [^ (MenuIcons perform: self icon) asMorph].
	
	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2.
	
	lm
		addMorphBack: (MenuIcons perform: self icon) asMorph;
		addMorphBack: morph.
	
	^ lm! !

!OBCmdChaseVariables methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 16:03'!
buttonLabelWithSpaces

	^ super buttonLabelWithSpaces! !

!OBCmdChaseVariables methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:47'!
icon

	^ #xpfCtBricksIcon! !

!OBCmdChaseVariables methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:47'!
iconOnly

	^ true! !

!OBCmdChaseVariables methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 16:06'!
longDescription

	^ 'chase variables'! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:56'!
xpfCtArrowDivideContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAI3SURBVDjLpZNNSJRxEMaf1XVV
yA/8iH1fKdEKIzwpSIeCLmkRUaaXSsE6tB3qYLIQeTUMCwqEKNI6hJHRNamwEDSXCENKoaKN
NjLCd9PDRuX7f2b+HUSzcLs4t2Hm+Q0zPBOw1mItkbEy6RiP9LSPnuhK19x6r6nn8MDBrlUB
Hc8iveFsN+rkOJ2nnhy78q+4ZbCp180ri7qFbmfjjb3L9UDH+MlMq9oXznHaNuVvgYjg3dwb
JOYT/UKJkAIx0ucUlLVVOVWgJabiU4jPxPtpJBJU1bMqWpuFEFQVFhakgEbqhBKlkUyStUJC
rEBVEQxmwfisEyPRgLUWp58e3xgKhBJ1znaoKh6/fYRbjYOBlSscuN5g62vrQSsYjg0j9T1V
PnIu9ikDAISyOFUEtITS4sidxtCy+FpDSI2CSlAJYwj68ueIQoEYQixBEYTzwqBh9xLA+Ox2
SlwYXazTX4QAQBAASJlZMP6cl/KK8nMLUF5agR+/fp7Zf3V3tVDgFLv1lRsqQCVmkx5SqdQc
KTMAEFgyUsvdQ82kDFSUVIbcYhcKC2/egwhRWFAEqkH84wdMTU/7Qjk6cfHV/b8AANB8c99m
Gukk2bq1fFvm+uJSqAo+f/2CickJEcptGjn/8tLr98s+WM3Key7v2rEuN2+0proGYhWx5zF4
yeTOFxcmx/5r5aV42D4y5n1LLvhi4NNg1vMWVhOnBQAAfWarVSgUNJKdri+YFmCIB0NDECMQ
StpvDKz1nX8D4+Fd1+gIFK0AAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:56'!
xpfCtArrowDivideIcon

	^ Icons
		at: #'xpfCtArrowDivide'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtArrowDivideContents readStream) ].! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:44'!
xpfCtBricksContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAALLSURBVDjLpZPfT1JhGMfprnnd
39B1986rtja3TEWGBJocEYbya+oBzgJRt8xwKjoCf1SgqKSiGUqlYiZzGpY6XebMXFOxocIF
K8p1c76d8zpXq9lNF8/27H2f7+f5Pu8PAQDB/8RfC2/u1WVErHTmS1oniyko7Bfmk4iVlmCG
1t6KWOhMvuZcwCpTHU0a9EioVTjiRCmGQYqmSZ7QlCNZacCyuSp6LuCjVMR+sVpx4uzAkboM
MYmQBJ/za/zeB3EOGzbqLhNAndeWYXRVZxocWpl5UI9d4XWkfT4ktRU45kbgRWewY5UScaqI
GykXHOAKAdz2GKMNIStsYyYwAQP2RDfwIxjCN7cLiQoVsZys0uNzkZSI+VH2Jfm/AJqeMtYx
fRe+xS5YR2lC5wFpdwfSTidSLc04lBcR8SFVfAr43YHSW4zZzSk4phvBjFRi52YB6Zx2d+Jr
eztSTXbES2REyAMOuO5bomzWZHNfNTf7MwTqHjmWPi1gaiOE4aV+dAfqMa+jsCvJIzfBu+DP
4kAmwY4wG7MKOWrtflR2R6BpGIgKyntLsbA9h4m1UQRXA/BHPTAN62CzuBClpNwN5GFXnIto
iQR3mDao2sJwTKzD4ltELjPECjReBTu2MoSRZT+GlnzwLnSBHtIg1/oET6M7qPe+grJlkoj4
4AHq9hnIm15AaAtCUOXQZ2nd6ri2T4WuOSf6X3vIWeTbxjCzFkNgfhueyXeo6XsNQ2cERfbn
RFzaOg1RXfD08ZycnFwwtOkUSheVrvApUN5LEfrkyh4G5rbwmItH0xuQN08SMcU54gHEwZ8v
Ud+qvaR3aC+Ka0dZb/g9POFNPOQc3OfsF9tPO/MAcf04coyD7Lm/TGXtyJJZeuISrtAeeAtX
aB2K1jCkjc+QYw5AbHyQoEzOa//8qvxo6pruskKmNy2uG+csj6HA2PtdbnZVn9X8BLLktmdB
dpY6AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:44'!
xpfCtBricksIcon

	^ Icons
		at: #'xpfCtBricks'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtBricksContents readStream) ].! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:38'!
xpfCtChartOrganisationContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAFOSURBVDjLtVK7SgNRED0b9iuM
2lr4QK1DQIyk0FZsJAj+gH+ilRZb2NjaRHTLmA9QFKz9huzm7t37Hu+u7IJgQjR6YLjDzOXM
mcMERIR5EE5qXA4z4sqACYWEC5wfLQXf/WtMIuDSoL0A7DZDjBj/uYI0l8jzEEJYJMkvCEZM
4PqZIxlzpGk+kSCY18TGtGYcx9Tv96dOqBUMBgNyzsFaC621312Ac+59yJFlGRhj5VvVoigK
vniglEK32w1mkd3r9ejPPAjOhqdknYX18p1/rzo3pYqTh0OSRkJI5UMgPn4s61sX66SkhtEG
cISGsQad5gH2FvehfV5BaIF2cwet5RZyKeu68pe5ubKG7dUNP5AQGltMN57Mosgr5EIiVQmY
Gvtc1PVicqHY+dXpk8Dg7v22XKFo1ARe9v1bDOlXKKKCs4Sn1xdU1v3vIc2CD3bN4xJjfJWv
AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:39'!
xpfCtChartOrganisationIcon

	^ Icons
			at: #'xpfCtChartOrganisation'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtChartOrganisationContents readStream) ].! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:33'!
xpfCtPageCodeContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAALESURBVBgZPcFLaJxlFIDh95zv
+//MJZObITUUq/QSG42orcULSnQhgmRjQRCyqaC4qLqrLgQ34gV040JKcOGiEMS9C0E3iVGE
WIu0pWClWAlpmsaZSRuTmfn+c8zY0ecRd6fr2XcXTpQH+mZVOAqUAKFLABdwI5n93tjw72Sz
fmrx9EybXeLudD3/wdLimTeOTqrKkEPA+Z87u5z1Wx3mlxtcu9r6++L5SyPfn55pRXo0yL15
DEMXrhNUBATcoHAjJWe7U/D0oRqPTkR+svWK2+H69OtfDys9ItLv7iEPSqYQBYJCEBABRQBj
fCBn5tg49xzsK8eB6hdKj4NstR0FVEBFUBFUBBVBg7D61zZ393e4b0R49fE7CFl4MdJjKB8t
NGkWzqnHRvn0XIOYYHaqRgxC7srlDadtCbM2T+3vQ6ImZddDH14Z8YGxPGaKtkBFIEGtDGfO
Nmm1nSwofXmglAdKeYajIIo++P6Vl6YOVVcm9/Vrs1HwyiMjqAgn7h9kvVFQKcPnP9dZ/m2L
LCp5CPRFxQB30MkD5bl9tVBarXd4+UiF4VrEgeGKcnyixlozMV4Vlv7cQoCoQgxKYVAY6Lnl
zdcur7Z2RvLA3GKTjUYHd2fjVuKrX+oMReWPtTZPjlfIVIkqBBVKmVAkRy99MvHl8lJ97/mL
dSuVlM++uUZhMLdwg2pJ2dro8Ob0GE9MDeCAOTiQBSW1E+LudE2/88P2/jv3lm60oXJ4D62r
62zehMGDo2gudLmDcdv8cxnPvLW4E+kxS7w3u4ePL+QcGVPswF0UDoWAOTjgDu7w6/WEm9PZ
SUR6UsssmXm7QH5cKTBxHKHLHATHHFwFNSFGsVRYivR0doq1ah5G336gXXV3xcG4bbAc6XKH
ciaIYFmQm0WyFXF3uo6d/PZk6vgLIvKw4xX+4+CA4/zL6doxs7MK8/8A73I7wFFcAY8AAAAA
SUVORK5CYII='! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:33'!
xpfCtPageCodeIcon

	^ Icons
			at: #'xpfCtPageCode'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtPageCodeContents readStream)].! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/28/2009 19:57'!
xpfCtSmallAddCommentIcon

	^ Icons
			at: #'xpfCtSmallAddComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMaximizeForm scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:51'!
xpfCtTimeIcon

	^ Icons
			at: #'xpfCtTime'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtTimeContents readStream)].! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:26'!
xpfCtTransmitBlueContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAALASURBVDjLhZJdSFNhGMcPSMJA
CLr1wptAkIIuC6zFKjJDb6QurNiFaCH2gWiFNh1rLodNJ/iBS5k5RdvcSSunpTYrc+QHSHFw
bmzNbWd+bE7FWFgnn/6TFrKsLh4OvLy///N7nvMyRMTsrq7xUCpK0/EuNK23BgXd66DQPLw8
XW9Z0jwcCKTG34+HiwFG+mfWaGh2g4Y/bdDL2XVip1apfSxI91k+UmHki/8IAJjYOR4aZCfD
9GJmnTreBqnx1RKhK9U8D5DqKY/vIrUMr1B1f4Cu6z2DV1vdib8D0FXLfgiTeXKNoCsAlEBX
FOtS3uMTlXZ5JbceewRVH09lPV663OTS7ATo3wQPt2LOvukwNQwtCbWWQIr6WSAJukroTtzt
9k0Ud3iVhXpPUoHOnSJtdgnyXp5y6pxCdo0jjWkZWdY+sYXo0ehKVFdSxfLJchPvrhtYokqT
n8q6fSTv9VNes8t9qcGVfLHeKUEI3Wj30FmVXcNA185OhUndz5PCzIuga6odWCToGgvb3OK8
FpcYusbbXV7KqXWYstQOUYZ6HsFeEis4joHulhnLgy5BNwG6kTvoCl2xzWbLtlqtadAVX2l0
UabaHjldNZdwUsGRzOijYzJunYHuVvf7VSrt9Ea3K7rW9jmqu1Jn/pgO+LvFYvlWrR/NgO7C
KeUcHVdwovRKbme0o+XcJoPtOpWsn6AbgW4idE9EtwvYYJ93kH3eSQaDoSN6ll7BHULXfQD9
51Tz0QCOwXZvQrcAi9kf+22AD6Dzptls3ga8rdPpeK1Wm7T7AQEWoy4w8U8zWoCbAAs+/yIt
eHkCLKhUqgd73d0LPgL4x6/O44DHAW/LZLIvJSUlB/8bAHgE8FfArbEzwAbAm0VFRew/AwCf
B+wHfC/+ImB5fn7+mFQqPfPXAMBgddl7zRotwFm5ubmZqITY2U/WPMCPgs5K+QAAAABJRU5E
rkJggg=='! !

!MenuIcons class methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:27'!
xpfCtTransmitBlueIcon

	^ Icons
			at: #'xpfCtTransmitBlue'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtTransmitBlueContents readStream)].! !

!OBCmdBrowseHierarchy methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 15:59'!
buttonLabelWithSpaces

	^ super buttonLabelWithSpaces! !

!OBCmdBrowseHierarchy methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:41'!
icon

	^ #xpfCtChartOrganisationIcon! !

!OBCmdBrowseHierarchy methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:42'!
iconOnly

	^ true! !

Object subclass: #SWAOBExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWAOBExtensions'!

!SWAOBExtension class methodsFor: 'initialization' stamp: 'rkrk 9/24/2009 22:26'!
initialize

	"self initialize"
	super initialize.
	self
		initializeInstVars;
		initializePreferences.! !

!SWAOBExtension class methodsFor: 'initialization' stamp: 'rkrk 9/24/2009 22:28'!
initializeInstVars

	(Smalltalk hasClassNamed: #OBButtonModel) ifFalse: [^ self].
	(OBButtonModel allInstVarNames includes: #icon) ifFalse: [
		OBButtonModel addInstVarName: #icon].
	(OBButtonModel allInstVarNames includes: #iconOnly) ifFalse: [
		OBButtonModel addInstVarName: #iconOnly].! !

!SWAOBExtension class methodsFor: 'initialization' stamp: 'rkrk 9/24/2009 22:34'!
initializePreferences

	Preferences
		valueOfPreference: #useMoreIconsForCommands
		ifAbsent: [Preferences
			addBooleanPreference: #useMoreIconsForCommands
			category: #SWAOBExtension
			default: true
			balloonHelp: 'Saves a little space and improves usability in the code browser by adding icons to command buttons.'].! !

!OBCommand methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 17:51'!
buttonLabelWithSpaces
	"Overwrite to use icons in button label."
	
	| lm pref |
	pref := (Preferences
		preferenceAt: #useMoreIconsForCommands
		ifAbsent: [Preference new rawValue: false])
		preferenceValue.

	self icon isNil | pref not ifTrue: [^ ' {1} ' format: {self buttonLabel}]. "the classic way"
	
	(self iconOnly or: [self buttonLabel isNil or: [self buttonLabel isEmpty]])
		ifTrue: [^ (MenuIcons perform: self icon) asMorph].

	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2.
		
	lm
		addMorphBack: (MenuIcons perform: self icon) asMorph;
		addMorphBack: self buttonLabel asMorph.

	^ lm! !

!OBCommand methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:23'!
iconOnly
	"Used to decide whether or not to use the label if an icon is present."

	^ false! !

!OBPackageBrowser class methodsFor: '*SWAOBExtensions-override' stamp: 'mt 5/30/2009 19:53'!
panels
	^ {
		self topPanel.
		self navigationPanel.
		self annotationPanel.
		self toolbarPanel.
		self definitionPanel} reject: [:ea | ea isNil]! !

!OBCmdBrowseInheritance methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:57'!
icon

	^ #xpfCtArrowDivideIcon! !

!OBCmdBrowseInheritance methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 15:57'!
iconOnly

	^ true! !

!OBCmdBrowseInheritance methodsFor: '*SWAOBExtensions' stamp: 'mt 5/30/2009 16:06'!
longDescription
	
	^ 'browse inheritance'! !
SWAOBExtension initialize!
